/*
    
    Copyright (C) 2007  William Quincy 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#ifndef _OBJECT_H
#define _OBJECT_H 

#include "world.h"

//TODO: only static or roto for now
#define OBJTYPESTATIC 1//sprite(what is called 'billboarding' in 3d)
#define OBJTYPEROTO 2//36 frame rotation
#define OBJTYPEANI 4//value will tell the type of animation
#define OBJTYPEREP 8//does it sound on collision//value1 will tell how to play the sound
#define OBJTYPECOL 16//is it solid//only shpere collions on objects

class Object
{
protected:  
    Bitmap bmp;
    VECT2d Vel;
    VECT2d Pos;
    float YVelocity;
    float ScaleX,ScaleY;
    int Index;
    int Angle;
    int Y;
    int MaxVelocity;
    int NumFrames;
    int Frame;
    int Width;
    int Height;
    int YOffset;
    signed char Value1;
    signed char Value2;
    byte Type;
public:
    Object();
    virtual void Move(void);
    virtual void Draw(Bitmap Dest, float CamX, float CamZ, int CamY, int CamAngle, int hori);
    float scalex(void){return ScaleX;}
    float scaley(void){return ScaleY;}
    float z(void){return Pos.z;}//*****inline*****//
    float x(void){return Pos.x;}//*****inline*****//
    int y(void){return Y;}//*****inline*****//
    int angle(void){return Angle;} //*****inline*****//
    int index(void){return Index;} 
    int height(void){return Height;}
    int width(void){return Width;}
    int yoffset(void){return YOffset;}
    int maxvelocity(void){return MaxVelocity;}
    int numframes(void){return NumFrames;}
    int frame(void){return Frame;}
    signed char value1(void){return Value1;}
    signed char value2(void){return Value2;}
    byte type(void){return Type;}
    void SetPos(float x, float z, int y, int angle);
    void SetX(float x){Pos.x = x;}//*****inline*****//
    void SetZ(float z){Pos.z = z;}//*****inline*****//
    void SetY(int y){Y = y;}//*****inline*****//
    void SetIndex(int x){Index = x;}//*****inline*****//
    void SetWidth(int width){Width = width;}//*****inline*****//
    void SetHeight(int height){Height = height;}//*****inline*****//
    void SetYOffset(int y){YOffset = y;}//*****inline*****//
    void SetAngle(int angle){Angle = angle;}//*****inline*****//
    void SetBmp(Bitmap b){bmp = b;}//*****inline*****//
    void SetType(byte t){Type = t;}//*****inline*****//
    void SetXScale(float x){ScaleX = x;}//*****inline*****//
    void SetYScale(float y){ScaleY = y;}//*****inline*****//
    void SetNumFrames(int num){NumFrames = num;}//*****inline*****//
    void SetValue1(int num){Value1 = num;}//*****inline*****//
    void SetValue2(int num){Value2 = num;}//*****inline*****//
    float GetXScale(void){return ScaleX;}//*****inline*****//
    float GetYScale(void){return ScaleY;}//*****inline*****//
    byte GetType(void){return Type;}//*****inline*****//
     
}; 

#endif
