/*
    
    Copyright (C) 2007  William Nelson Quincy Jr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#include "world.h"
#include "pointer.h"
#include "object.h"
#include "plane.h"
#include "HUD.h"
#include "Map.h"

#define ChaseCamDist 70.0

#define MAXOBJECTS  100
#define PLAYER1 0
#define PLAYER2 1
#define PLAYER3 2
#define PLAYER4 3
#define NUMPLAYERS 4

#define MAXPLANES 99
#define MAXBITMAP 95

#define HORIZION 100

typedef struct CAMERA
{
    int angle,y; 
    float x,z;
} CAMERA;

typedef struct ObjectHold
{
   Object *Obj;
   float dist;
}ObjectHold;
ObjectHold ObjectsDist[MAXOBJECTS+NUMPLAYERS];  
Object Objects[MAXOBJECTS];
int ObjectCounter =0;

CPointer Pointer;

Plane Planes[MAXPLANES];
int PlaneCounter =0;

Bitmap Backbuffer;
Bitmap bmpPointer;
Bitmap Board;
Bitmap BmpStore[MAXBITMAP];
char BitmapNames[MAXBITMAP][128];

int BmpCounter;

DIALOG_PLAYER *player ;

volatile int gcounter;
int cycles;



char tmpString[32];
char skyfile[128] = "data\\sky.bmp";
char savefile[128] = "data\\test.brd";
char loadfile[128] = "data\\test.brd";

float SinTable[MAXDEGREES];
float CosTable[MAXDEGREES];
float RCosTable[MAXDEGREES];
float RadTable[MAXDEGREES];
float ViewHeight[MAXCAMHEIGHT];

int MaxFloorTex = 0;

int CurrentObject;
int CurrentPlane;

byte MapVersion = 0;

void LoadObjects(char *FileName);
void SaveObjects(char *FileName);
void LoadNewObjects(char *FileName);
void DrawObjects(Bitmap bmp, CAMERA Camera, int Hori);
void SortObjects(int first, int last);
void SetObject(int Edit);

//dialogs
int dTileNumChange(int msg, DIALOG *d, int c);
int dTileNumChangeD(int msg, DIALOG *d, int c);
int dObjNumChange(int msg, DIALOG *d, int c);
int dObjNumChangeD(int msg, DIALOG *d, int c);
int dEditTile(int msg, DIALOG *d, int c);
int dTileAngle(int msg, DIALOG *d, int c);
int s_bitmap_proc(int msg, DIALOG *d, int c);
int d_vline_proc(int msg, DIALOG *d, int c);
int d_hline_proc(int msg, DIALOG *d, int c);
int s_slider_proc(int msg, DIALOG *d, int c);
int sc_slider_proc(int msg, DIALOG *d, int c);
int f_slider_proc(int msg, DIALOG *d, int c);
int dGridSize(int msg, DIALOG *d, int c);
