/*
    
    Copyright (C) 2007  William Quincy 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/   

/**************************************************************************
I am sorry that the code is so messy, but I release it in the hopes that
it will be a useful reference on floorcasting, and objects in the 
floorcasting world. I DO NOT RELEASE THIS FOR YOU TO JUST START USING.
(your free to if you want) I suggest you start completely over. 
**************************************************************************/

#include "main.h"



int find_angle_cam(CAMERA obj1, Object obj2)
{
    //finds the angle between the camera and object
    //so I can clip to the screen.
    
    //returns 0 if object is straight ahead of camera.
    //positive degrees up to half circle each way.
    //if you need negitive degrees one way and positive
    //the other then see below. Same if you just
    //want degrees in full circle.
    float angle;
    int retAngle;
    
    //this will make errors sometimes which just makes a false negitive
    //angle. you should use atan and check quardants yourself.
    //but it just means a couple of sprites offscreen will be processed.
    //so I'm leaving it for now(using abs() on the return fixes it).
    angle = atan2(obj2.x() - obj1.x, obj2.z() - obj1.z);

    angle *= RADDEG; 
  
    retAngle = obj1.angle - (int)(angle) - THREEQUARTERCIRCLE;
    if(retAngle<0){retAngle+=MAXDEGREES;}    
    if(retAngle>HALFCIRCLE){retAngle = MAXDEGREES-retAngle;}
    //the next line returns half circle ... 0 ... -halfcircle
    ////////if(retAngle>HALFCIRCLE){retAngle -= MAXDEGREES;}   
    //use neither to return 0...fullcircle(maybe?)               
    return abs(retAngle);           

}




void LoadObjects(char *FileName)
{
    FILE *fp;
    float ftemp;
    long WorldOffSet;
    int x,y,i,WriteRet,itemp;
    signed char ctemp;
    byte btemp;
    byte MapVersion;
    int BmpCounter;
    char BitmapNames[99][128];
        
    fp=fopen(FileName,"r+b");
    
    fread(&MapVersion,sizeof(MapVersion),1,fp);
    //TODO:check map version     
    
    fread(&WorldOffSet,sizeof(WorldOffSet),1,fp);
    
    fread(&BmpCounter,sizeof(BmpCounter),1,fp);
    for(i=4;i<BmpCounter+4;i++)
    {
        fread(&BitmapNames[i],sizeof(BitmapNames[i]),1,fp);
        destroy_bitmap(BmpStore[i]);
        BmpStore[i]=load_bitmap(BitmapNames[i],NULL);
        if(!BmpStore[i])
        {    
            BmpStore[i] = create_bitmap(TILEWIDTH,TILEHEIGHT);
            clear_bitmap(BmpStore[i]);  
            textout_centre_ex(BmpStore[i],font,"X X",TILEWIDTH/2,TILEHEIGHT/2,makecol(255,30,30),-1);
            
        }  
    }          
    
    fread(&ObjectCounter,sizeof(ObjectCounter),1,fp);
    for(i=0;i<ObjectCounter;i++)
    {
        fread(&ftemp,sizeof(float),1,fp);
        Objects[i].SetX(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Objects[i].SetZ(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Objects[i].SetXScale(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Objects[i].SetYScale(ftemp);
        fread(&itemp,2,1,fp);
        Objects[i].SetBmp(BmpStore[itemp+4]);
        Objects[i].SetIndex(itemp+4);
        fread(&itemp,2,1,fp);
        Objects[i].SetAngle(itemp);
        fread(&itemp,2,1,fp);
        Objects[i].SetY(itemp);
        fread(&itemp,2,1,fp);
        Objects[i].SetNumFrames(itemp);
        fread(&itemp,2,1,fp);
        Objects[i].SetWidth(itemp);
        fread(&itemp,2,1,fp);
        Objects[i].SetHeight(itemp);
        fread(&itemp,2,1,fp);
        Objects[i].SetYOffset(itemp);
        fread(&ctemp,1,1,fp);
        Objects[i].SetValue1(ctemp);
        fread(&ctemp,1,1,fp); 
        Objects[i].SetValue2(ctemp);
        fread(&btemp,1,1,fp);
        Objects[i].SetType(btemp); 
    }   
    
    fread(&PlaneCounter,sizeof(PlaneCounter),1,fp);
    for(i=0;i<PlaneCounter;i++)
    {
        fread(&ftemp,sizeof(float),1,fp);
        Planes[i].SetX(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Planes[i].SetZ(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Planes[i].SetXScale(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Planes[i].SetYScale(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Planes[i].SetCellW(ftemp);
        fread(&ftemp,sizeof(float),1,fp);
        Planes[i].SetCellH(ftemp);
        fread(&itemp,2,1,fp);
        Planes[i].SetBmp(BmpStore[itemp+4]);
        Planes[i].SetIndex(itemp+4);
        fread(&itemp,2,1,fp);
        Planes[i].SetAngle(itemp);
        fread(&itemp,2,1,fp);
        Planes[i].SetY(itemp);
        fread(&itemp,2,1,fp);
        Planes[i].SetNumFrames(itemp);
        fread(&itemp,2,1,fp);
        Planes[i].SetWidth(itemp);
        fread(&itemp,2,1,fp);
        Planes[i].SetHeight(itemp);
        fread(&itemp,2,1,fp);
        Planes[i].SetYOffset(itemp);
        fread(&ctemp,1,1,fp);
        Planes[i].SetValue1(ctemp);
        fread(&ctemp,1,1,fp); 
        Planes[i].SetValue2(ctemp);
        fread(&btemp,1,1,fp);
        Planes[i].SetType(btemp); 
    }    
    
    fclose(fp);
       
       Racers[0].SetX(0.0);
       Racers[0].SetY(0);
       Racers[0].SetZ(0.0);
       Racers[0].SetXScale(75);
       Racers[0].SetYScale(75);
       Racers[0].SetType(0);
       Racers[0].SetWidth(138);
       Racers[0].SetHeight(66);
       Racers[0].SetBmp(BmpStore[0]);//RedRacer);
       Racers[0].SetYOffset(10);
       
       Racers[1].SetX(0.0);
       Racers[1].SetY(0);
       Racers[1].SetZ(0.0);
       Racers[1].SetXScale(75);//50 when shrunk
       Racers[1].SetYScale(75);
       Racers[1].SetType(0);
       Racers[1].SetWidth(138);
       Racers[1].SetHeight(66);
       Racers[1].SetBmp(BmpStore[1]);//GreenRacer);
       Racers[1].SetYOffset(10);
       
       Racers[2].SetX(1500.0);
       Racers[2].SetY(0);
       Racers[2].SetZ(0.0);
       Racers[2].SetXScale(75);
       Racers[2].SetYScale(75);
       Racers[2].SetType(0);
       Racers[2].SetWidth(138);
       Racers[2].SetHeight(66);
       Racers[2].SetBmp(BmpStore[2]);//YellowRacer);
       Racers[2].SetYOffset(10);
       
       Racers[3].SetX(0.0);
       Racers[3].SetY(0);
       Racers[3].SetZ(1500.0);
       Racers[3].SetXScale(75);//50 when shrunk
       Racers[3].SetYScale(75);
       Racers[3].SetType(0);
       Racers[3].SetWidth(138);
       Racers[3].SetHeight(66);
       Racers[3].SetBmp(BmpStore[3]);//BlueRacer);
       Racers[3].SetYOffset(10);
       
}    

void SortObjects(int first, int last)
{
   //quick sort the visible objects.
    
   ObjectHold temp;
   float separator;
   int low, high;
   
   low = first;
   high = last;
   separator = ObjectsDist[(first + last)>>1].dist;
   
   do
   {
      while (ObjectsDist[low].dist < separator)
         low++;
      while (ObjectsDist[high].dist > separator)
         high--;
      if(low <= high)
      {
         temp = ObjectsDist[low];
         ObjectsDist[low++] =  ObjectsDist[high];
         ObjectsDist[high--] = temp;
      }
   }while (low <= high);
   if (first < high)
      SortObjects(first, high);
   if (last > low)
      SortObjects(low, last);
 }
 

void DrawObjects(Bitmap bmp, CAMERA camera, int Hori)
{
    //goes through all objects, uses a cheap, but fairly fast, frustum
    //clipping, preceeded by a dist clipping. Then sorts the visible
    //objects and draws them.  
    float dist;
    int i;
    int Visible = 0;
    int tmpAngle;
        
    for (i=0;i<ObjectCounter;i++)
    {
        //dist = sqrt((Objects[i].Z()-camera.z) * (Objects[i].Z()-camera.z)+(Objects[i].X()-camera.x) * (Objects[i].X()-camera.x)); 
        dist = fabs(camera.x - Objects[i].x()) + fabs (camera.z - Objects[i].z()) ;
        if (dist < 1000)
        {
            tmpAngle = find_angle_cam(camera,Objects[i]);
            if(tmpAngle < 270 )
            { 
               ObjectsDist[Visible].dist = dist;
               ObjectsDist[Visible].Obj = &Objects[i];
               Visible++;
            }       
        }        
    }
    
    for (i=0;i<PlaneCounter;i++)
    {
        //dist = sqrt((Planes[i].Z()-camera.z) * (Planes[i].Z()-camera.z)+(Planes[i].X()-camera.x) * (Planes[i].X()-camera.x)); 
        dist = fabs(camera.x - Planes[i].x()) + fabs (camera.z - Planes[i].z()) ;
        if (dist < 1000 && dist > 40)
        {
            tmpAngle = find_angle_cam(camera,Planes[i]);
            if(tmpAngle < 400)
            { 
                if(Planes[i].GetType() == DECAL)
                {
                   Planes[i].Draw(bmp,camera.x,camera.z,camera.y,camera.angle,Hori);
                }           
                else
                {
                   ObjectsDist[Visible].dist = dist;
                   ObjectsDist[Visible].Obj = &Planes[i];
                   Visible++;
               }    
            }       
        }        
    }
    
    for (i=0;i<NUMPLAYERS;i++)
    {
        //dist = sqrt((Racers[i].Z()-camera.z) * (Racers[i].Z()-camera.z)+(Racers[i].X()-camera.x) * (Racers[i].X()-camera.x)); 
        dist = fabs(camera.x - Racers[i].x()) + fabs (camera.z - Racers[i].z()) ;
        if (dist < 1000)
        {
            
            tmpAngle = find_angle_cam(camera,Racers[i]);
            if(tmpAngle < 270 )//you can increase this if you get too many "pop-outs"
            {                  //using just the one angle gets a lot of off screen
                               //sprites being processed. It would be tighter to check
                               //the angle from each side of the screen
                ObjectsDist[Visible].dist = dist;
                ObjectsDist[Visible].Obj = &Racers[i];
                Visible++;
            }    
        }        
    }    
    
    SortObjects(0,Visible-1);
  
    for (i=Visible-1;i>=0;i--)
    {
        ObjectsDist[i].Obj->Draw(bmp,camera.x,camera.z,camera.y,camera.angle,Hori);    
    }    
    char tmpString[32];
    sprintf(tmpString,"Visible: %d",Visible);
    textout_ex(bmp,font,tmpString,10,10,makecol(255,0,0),-1);
}        


void gtimer()
{
    gcounter++;
}
END_OF_FUNCTION(gtimer);



void GameLoop()
{
   //The width of the rendered view can be anything from 1 to 640(or 480-
   //as set by RENDERSIZE in globals.h) but make sure the right edge won't
   //go past 640(edge of bitmap rendered to.). So if you set the left edge
   //at 10 then a width of 640 won't work right. But 630 will.
   
   
   World theWorld1;
   CAMERA Camera1[7];
   CAMERA Camera2[7];
   HUD Hud1(Backbuffer,10,187,480, 50);
   HUD Hud2(Backbuffer,150,422,480, 50);
   Map Map1(Backbuffer,496,14,128,128);
   Map Map2(Backbuffer,16,249,128,128);
   int Keys2[KEYMAX]={KEY_W,KEY_S,KEY_A,KEY_D,KEY_TAB};
   int Keys1[KEYMAX]={KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,KEY_SLASH};
   int GameOver = 0;
   int i;
   int ChaseCounter = 1;
   int AdjustAng;
   float zup , xup;
   
   Bitmap Pl1Canvas, Pl2Canvas;
   Pl1Canvas = create_sub_bitmap(Backbuffer,10,8,480,180);
   Pl2Canvas = create_sub_bitmap(Backbuffer,150,243,480,180);
   
   LoadObjects("data\\test.brd");
   
   //set up inital chasecam array
   for(i=0;i<7;i++)
   {
       AdjustAng = Racers[PLAYER1].angle()+QUARTERCIRCLE;
       if(AdjustAng>=MAXDEGREES){AdjustAng-=MAXDEGREES;}
        
       zup = -CosTable[AdjustAng] * ChaseCamDist;
       xup = -SinTable[AdjustAng] * ChaseCamDist;
                
       Camera1[i].x = Racers[PLAYER1].x()-1 + xup;
       Camera1[i].z = Racers[PLAYER1].z()-1 + zup;
       Camera1[i].y = Racers[PLAYER1].y() + 14;
       Camera1[i].angle = Racers[PLAYER1].angle();
        
       AdjustAng = Racers[PLAYER2].angle()+QUARTERCIRCLE;
       if(AdjustAng>=MAXDEGREES){AdjustAng-=MAXDEGREES;}
        
       zup = -CosTable[AdjustAng] * ChaseCamDist;
       xup = -SinTable[AdjustAng] * ChaseCamDist;
        
       Camera2[i].x = Racers[PLAYER2].x()-1 + xup;
       Camera2[i].z = Racers[PLAYER2].z()-1 + zup;
       Camera2[i].y = Racers[PLAYER2].y() + 14;
       Camera2[i].angle = Racers[PLAYER2].angle();

       if(Camera1[i].y > MAXCAMHEIGHT){Camera1[i].y = MAXCAMHEIGHT;}
       if(Camera1[i].y < 14){Camera1[i].y = 14;}
       if(Camera2[i].y > MAXCAMHEIGHT){Camera2[i].y = MAXCAMHEIGHT;}
       if(Camera2[i].y < 14){Camera2[i].y = 14;}
   }    
       
   blit(Board,Backbuffer,0,0,0,0,SCREENW,SCREENH);
   
   theWorld1.LoadMap("data\\test.brd");
   
   Map1.UpdateTiles(theWorld1);
   Map2.UpdateTiles(theWorld1);
      
   Hud1.SetFont(font);
   Hud2.SetFont(font);
   
   Racers[PLAYER1].SetKeys(Keys1);
   Racers[PLAYER2].SetKeys(Keys2);
   
   do
   {
      while(gcounter)
      {
        Racers[PLAYER1].Move(theWorld1);
        Racers[PLAYER2].Move(theWorld1);
          
        AdjustAng = Racers[PLAYER1].angle()+QUARTERCIRCLE;
        if(AdjustAng>=MAXDEGREES){AdjustAng-=MAXDEGREES;}
        
        zup = -CosTable[AdjustAng] * ChaseCamDist;
        xup = -SinTable[AdjustAng] * ChaseCamDist;
        
        Camera1[ChaseCounter].x = Racers[PLAYER1].x()-1 + xup;
        Camera1[ChaseCounter].z = Racers[PLAYER1].z()-1 + zup;
        Camera1[ChaseCounter].y = Racers[PLAYER1].y() + 14;
        Camera1[ChaseCounter].angle = Racers[PLAYER1].angle();
        
        AdjustAng = Racers[PLAYER2].angle()+QUARTERCIRCLE;
        if(AdjustAng>=MAXDEGREES){AdjustAng-=MAXDEGREES;}
        
        zup = -CosTable[AdjustAng] * ChaseCamDist;
        xup = -SinTable[AdjustAng] * ChaseCamDist;
        
        Camera2[ChaseCounter].x = Racers[PLAYER2].x()-1 + xup;
        Camera2[ChaseCounter].z = Racers[PLAYER2].z()-1 + zup;
        Camera2[ChaseCounter].y = Racers[PLAYER2].y() + 14;
        Camera2[ChaseCounter].angle = Racers[PLAYER2].angle();
        
        if(Camera1[ChaseCounter].y > MAXCAMHEIGHT){Camera1[ChaseCounter].y = MAXCAMHEIGHT;}
        if(Camera1[ChaseCounter].y < 14){Camera1[ChaseCounter].y = 14;}
        if(Camera2[ChaseCounter].y > MAXCAMHEIGHT){Camera2[ChaseCounter].y = MAXCAMHEIGHT;}
        if(Camera2[ChaseCounter].y < 14){Camera2[ChaseCounter].y = 14;}
          
        if(key[KEY_F12]!=0)
        {
            save_bmp("Screen.bmp",Backbuffer,NULL);
        }    
        ChaseCounter++;
        if(ChaseCounter>6) ChaseCounter=0;
        
        theWorld1.AnimateTiles();
        
        for (i=0;i<PlaneCounter;i++)
        {
           Planes[i].Move();
        }    
       
         gcounter--;
       }
        
        theWorld1.DrawSky(Pl1Canvas,Camera1[ChaseCounter].x,Camera1[ChaseCounter].z,Camera1[ChaseCounter].y,Camera1[ChaseCounter].angle, HORIZION);
        theWorld1.DrawSky(Pl2Canvas,Camera2[ChaseCounter].x,Camera2[ChaseCounter].z,Camera2[ChaseCounter].y,Camera2[ChaseCounter].angle, HORIZION);
        
        theWorld1.DrawGround(Pl1Canvas,Camera1[ChaseCounter].x,Camera1[ChaseCounter].z,Camera1[ChaseCounter].y,Camera1[ChaseCounter].angle, HORIZION);
        theWorld1.DrawGround(Pl2Canvas,Camera2[ChaseCounter].x,Camera2[ChaseCounter].z,Camera2[ChaseCounter].y,Camera2[ChaseCounter].angle, HORIZION);
        
        DrawObjects(Pl1Canvas,Camera1[ChaseCounter], HORIZION);
        DrawObjects(Pl2Canvas,Camera2[ChaseCounter], HORIZION);
        
        Map1.Blit();
        Racers[PLAYER1].DrawPos(Map1.GetCanvas(),makecol(255,0,0));
        Racers[PLAYER2].DrawPos(Map1.GetCanvas(),makecol(0,255,0));
        Racers[PLAYER3].DrawPos(Map1.GetCanvas(),makecol(0,0,255));
        Racers[PLAYER4].DrawPos(Map1.GetCanvas(),makecol(255,255,0));
            
        Map2.Blit();
        Racers[PLAYER1].DrawPos(Map2.GetCanvas(),makecol(255,0,0));
        Racers[PLAYER2].DrawPos(Map2.GetCanvas(),makecol(0,255,0));
        Racers[PLAYER3].DrawPos(Map2.GetCanvas(),makecol(0,0,255));
        Racers[PLAYER4].DrawPos(Map2.GetCanvas(),makecol(255,255,0));
                
        Hud1.Clear();
        sprintf(tmpString,"X: %f",Racers[PLAYER1].x());
        Hud1.TextOut(tmpString,10,1,makecol(255,255,0),-1);
        sprintf(tmpString,"Z: %f",Racers[PLAYER1].z());
        Hud1.TextOut(tmpString,10,15,makecol(255,255,0),-1);
        sprintf(tmpString,"Y: %d",Racers[PLAYER1].y());
        Hud1.TextOut(tmpString,10,29,makecol(255,255,0),-1);
        sprintf(tmpString,"A: %d",Racers[PLAYER1].angle()>>3);
        Hud1.TextOut(tmpString,200,10,makecol(255,255,0),-1);
                
        sprintf(tmpString,"X: %f",Racers[PLAYER2].x());
        Hud2.Clear();
        Hud2.TextOut(tmpString,10,10,makecol(255,255,0),-1);
         
        //vsync();
        blit(Backbuffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
        Racers[PLAYER1].DisplayStat();
        if(key[KEY_ESC]!=0){GameOver=1;}
        
    }while(GameOver==0);
    destroy_bitmap(Pl1Canvas);
    destroy_bitmap(Pl2Canvas);
   
   
}    


void Init()
{
    
    int Card = GFX_AUTODETECT_FULLSCREEN;//GFX_DIRECTX_SAFE;//GFX_DIRECTX_SOFT;//GFX_AUTODETECT_WINDOWED;//
    allegro_init();
    #if BPP == 32
    set_color_depth(32);
    if (set_gfx_mode(Card, SCREENW, SCREENH, 0, 0) < 0) 
    {
      #ifdef LOGGING
          MessageOut("log.txt","Error setting GFX mode.");
      #endif 
      exit(0);
    }    
    #else
    set_color_depth(16);
    if (set_gfx_mode(Card, SCREENW, SCREENH, 0, 0) < 0) 
    {
        set_color_depth(15);
        if (set_gfx_mode(Card, SCREENW, SCREENH, 0, 0) < 0) 
        {
            #ifdef LOGGING
               MessageOut("log.txt","Error setting GFX mode.");
            #endif 
            exit(0);
        }
    }    
    #endif
    set_color_conversion(COLORCONV_TOTAL);                                                
    
                                                                                         
    Backbuffer=create_bitmap(SCREEN_W,SCREEN_H);
    BmpStore[0] = load_bitmap("data\\racers\\red.bmp",NULL);
    BmpStore[1] = load_bitmap("data\\racers\\red.bmp",NULL);
    BmpStore[2] = load_bitmap("data\\racers\\red.bmp",NULL);
    BmpStore[3] = load_bitmap("data\\racers\\red.bmp",NULL);
    Board = load_bitmap("data\\board.bmp",NULL);
    clear(Backbuffer);
    install_keyboard();
    install_mouse();
    install_timer();
    
    LOCK_FUNCTION(gtimer);
    LOCK_VARIABLE(gcounter);
    install_int_ex(gtimer,BPS_TO_TIMER(33));
    BuildTables();
    #ifdef LOGGING
       MessageOut("log.txt","Allegro init complete");
    #endif 
}



void ShutDown()
{
   int i;
   destroy_bitmap(Backbuffer);
   destroy_bitmap(Board);
   for(i=0;i<MAXBITMAPS;i++)
   {
       destroy_bitmap(BmpStore[i]);
   }       
   
   #ifdef LOGGING
       MessageOut("log.txt","Clean exit");
   #endif 

}

int main()
{
    #ifdef LOGGING
    char temp[128];
    MessageOut("log.txt","******NEW*LOG***********");
    sprintf(temp,"Version Beta. \nDate: %s", __DATE__);
    MessageOut("log.txt",temp);
	#endif
    Init();
    GameLoop();
    ShutDown();
    return(0);
}
END_OF_MAIN();
