/*
    
    Copyright (C) 2007  William Quincy 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#include "world.h"
#include "Racer.h"
#include "object.h"
#include "plane.h"
#include "HUD.h"
#include "Map.h"



#define ChaseCamDist 70.0

#define MAXOBJECTS  99
#define MAXBITMAPS 99   
#define PLAYER1 0
#define PLAYER2 1
#define PLAYER3 2
#define PLAYER4 3
#define NUMPLAYERS 4

#define MAXPLANES 99

#define HORIZION 100

typedef struct CAMERA
{
    int angle,y; 
    float x,z;
} CAMERA;

typedef struct ObjectHold
{
   Object *Obj;
   float dist;
}ObjectHold;
ObjectHold ObjectsDist[MAXOBJECTS+NUMPLAYERS];  
Object Objects[MAXOBJECTS];
int ObjectCounter;


Plane Planes[MAXPLANES];
int PlaneCounter;

Racer Racers[NUMPLAYERS];

Bitmap Backbuffer;
Bitmap Board;
Bitmap BmpStore[MAXBITMAPS];

volatile int gcounter;
int cycles;


char tmpString[32];

#ifdef LOGGING
  //char LogFileName;
#endif

float SinTable[MAXDEGREES];
float CosTable[MAXDEGREES];
float RCosTable[MAXDEGREES];
float RadTable[MAXDEGREES];
float ViewHeight[MAXCAMHEIGHT];

void LoadObjects(char *FileName);
void DrawObjects(Bitmap bmp, CAMERA Camera, int Hori);
void SortObjects(int first, int last);
//int compare_objects(ObjectHold *a, ObjectHold *b);

